<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

class OXDATE_CTRL_Ajax extends BASE_CTRL_Join
{
    public function promoImageUpload( $params )
    {
        if ( !OW::getUser()->isAuthenticated() || !OW::getUser()->isAuthorized('admin') )
        {
            throw new AuthorizationException();
        }
        
        if ( !OW::getRequest()->isAjax() || empty($_POST['command']) )
        {
            throw new Redirect404Exception();
        }
        
        $data = array();
        switch( $_POST['command'] ) 
        {
            case 'upload':

                $uploaddir = OW::getPluginManager()->getPlugin('oxdate')->getUserFilesDir();

                if( !empty($_FILES[0]['name']) )
                {
                    $file = $_FILES[0];

                    if( !UTIL_File::validateImage($file['name']) )
                    {
                        echo json_encode(array('result' => false, 'message' => OW::getLanguage()->text('base', 'not_valid_image')));
                        exit;
                    }

                    $errorCode = $file['error'];

                    if ( $errorCode > 0 )
                    {
                        $error = BOL_FileService::getInstance()->getUploadErrorMessage($errorCode);
                        echo json_encode(array('result' => false, 'message' => $error));
                        exit;
                    }

                    if( !UTIL_File::checkDir($uploaddir) )
                    {
                        echo json_encode(array('result' => false, 'message' => OW::getLanguage()->text('base', 'not_valid_image')));
                        exit;
                    }
                    $path = OXDATE_BOL_Service::getInstance()->getPromoImagePath();
                    
                    if ( file_exists($path) )
                    {
                        unlink($path);
                    }

                    if( move_uploaded_file( $file['tmp_name'], $path ) )
                    {
                        $data = array('result' => true, 'url' => OXDATE_BOL_Service::getInstance()->getPromoImageUrl().'?a='. rand() * 1000000, 'message' => OW::getLanguage()->text('oxdate', 'promo_image_upload_success'));

                        OXDATE_BOL_Service::getInstance()->setPromoImageUploaded();
                    }
                    else
                    {
                        $data = array('result' => false, 'message' => OW::getLanguage()->text('oxdate', 'promo_image_upload_error'));
                    }
                }
                
                break;
                
            case 'delete':
                
                $path = OXDATE_BOL_Service::getInstance()->getPromoImagePath();
                @unlink($path);
                
                 OXDATE_BOL_Service::getInstance()->setPromoImageUploaded(false);
                
                $data = array('result' => true, 'message' => OW::getLanguage()->text('oxdate', 'promo_image_deleted'));
                
                break;
        }
        
        echo json_encode($data);
        exit;
    }
}