(function( $, logic )
{
    this.OXDATE_ME_SETTINGS = function( params )
    {
        logic.call(this, $, params);
    }.bind(this);
}.call(window, jQuery, function( $, params, ud )
{
    var root = this, form = root.document.querySelector('form.settings_form'),

        banners = $('[name="banners\[\]"]', form),
        iosBanner = banners.filter('[value="oxdateios"]'),
        androidBanner = banners.filter('[value="oxandroid"]'),

        sf = $('[name="show_first\[\]"]', form),
        iosSF = sf.filter('[value="oxdateios"]'),
        androidSF = sf.filter('[value="oxandroid"]');

    if ( !params.iosActive || !params.androidActive )
    {
        hideInput(!params.iosActive ? iosBanner : androidBanner);

        hideInput(!params.iosActive ? iosSF : androidSF);
        $(!params.iosActive ? androidSF: iosSF).attr({checked: 'checked', disabled: 'disabled'});
    }
    else
    {
        if ( !iosBanner.attr('checked') )
        {
            hideInput(iosSF);
        }

        if ( !androidBanner.attr('checked') )
        {
            hideInput(androidSF);
        }

        banners.on('click', function()
        {
            var input;

            switch ( this.value )
            {
                case 'oxdateios':
                    input = iosSF;
                    break;
                case 'oxandroid':
                    input = androidSF;
                    break;
            }

            if ( this.checked )
            {
                showInput(input);
            }
            else
            {
                hideInput(input);
            }

            sf.filter(':visible:first').attr('checked', 'checked');
        });
    }

    function hideInput( input )
    {
        input.closest('li').hide();
    }

    function showInput( input )
    {
        input.closest('li').show();
    }
}));
