<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.
 * Pass on to others in any form are not permitted provided.
 * Sale are not permitted provided.
 * Sale this product are not permitted provided.
 * Gift this product are not permitted provided.
 * This plugin should be bought from the developer by paying money to PayPal account: biuro@grafnet.pl
 * Legal purchase is possible only on the official website URL: http://www.oxdate.org/
 * Modyfing of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Modifying source code, all information like: copyright must remain.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class USEARCH_MCTRL_Search extends USEARCH_CTRL_Search
{
    public function form()
    {
        $url = OW::getPluginManager()->getPlugin('usearch')->getStaticCssUrl() . 'search.css';
        OW::getDocument()->addStyleSheet($url);

        $mainSearchForm = OW::getClassInstance('USEARCH_MCLASS_MainSearchForm', $this);
        $mainSearchForm->process($_POST);        
        $this->addForm($mainSearchForm);
        
        $this->setTemplate(OW::getPluginManager()->getPlugin('usearch')->getMobileCtrlViewDir() . 'search_form.html');
        $this->assign('presentationToClass', BASE_MCLASS_JoinFormUtlis::presentationToCssClass());
    }
    
    public function quickSearch()
    {
        $this->addComponent("searchCmp", OW::getClassInstance('USEARCH_MCMP_QuickSearch'));
        $this->setTemplate(OW::getPluginManager()->getPlugin('usearch')->getMobileCtrlViewDir() . 'search_quick_search.html');
    }
    
    public function searchResult($params)
    {
        parent::searchResult($params);
        $orderType = $this->getOrderType($params);
        $this->assign('listLabel', $this->getListLabel($orderType));
        $this->setTemplate(OW::getPluginManager()->getPlugin('usearch')->getMobileCtrlViewDir() . 'search_search_result.html');
        
        $this->assign('noUsersTxt', strip_tags(OW::getLanguage()->text('usearch', 'no_users_found')));
    }
    
    public function map()
    {
        $searchResultMenu = $this->searchResultMenu(USEARCH_BOL_Service::LIST_ORDER_WITHOUT_SORT);
        
        if ( !empty($searchResultMenu) )
        {
            $this->addComponent('searchResultMenu', $searchResultMenu);
        }
        
        parent::map();
        $this->setTemplate(OW::getPluginManager()->getPlugin('usearch')->getMobileCtrlViewDir() . 'search_map.html');
    }
    
    protected function getListLabel($order)
    {
        $items = USEARCH_BOL_Service::getInstance()->getSearchResultMenu($order);
        
        foreach($items as $item) {
            if( !empty($item['isActive']) ) 
            {
                return $item['label'];
            }
        }
        
        return null;
    }
    
    public function searchResultMenu( $orderType )
    {
        $items = USEARCH_BOL_Service::getInstance()->getSearchResultMenu($orderType);
        
        $list = array();
        $order = 0;
        if ( !empty($items) )
        {
            foreach( $items as $item ) {
                $list[] = array( 
                    'label' => $item['label'], 
                    'href' => $item['url'],
                    'class' => '', 
                    'order' => $order++
                );
            }
        }
        
        $list[] = array( 
                    'label' => OW::getLanguage()->text('usearch', 'map'), 
                    'href' => OW::getRouter()->urlForRoute('usearch.map'),
                    'class' => '', 
                    'order' => $order++
                );
            
        $list[] = array( 
                    'label' => OW::getLanguage()->text('usearch', 'new_search'), 
                    'href' => OW::getRouter()->urlForRoute('users-search'),
                    'class' => '', 
                    'order' => $order++
                );
        
        $actions = new BASE_MCMP_ContextAction($list);
        
        return $actions;
    }
}